$(document).ready(function () {

    $('#sidebarCollapse').on('click', function () {
        $('aside, .sidebar').toggleClass('active');
    });
});

$(document).ready(function () {
    
    // Attach event listeners to the sidebar links/buttons to add active class
    var urlParams = new URLSearchParams(window.location.search);
    var currentPageId = urlParams.get('topic');
    
    $('#' + currentPageId).addClass('item-active');
})

// create the timestamp element
function addTimestamp(containerID, videoButton, deleteButton) {
    
  var container = document.getElementById(containerID);    
  var row = document.createElement('div');
  row.className = 'row mb-4';

  var col1 = document.createElement('div');
  col1.className = 'col';
  var label1 = document.createElement('label');
  label1.setAttribute('for', 'timestamps[]');
  label1.className = 'form-label';
  label1.textContent = 'TimeStamp: ';
  var input1 = document.createElement('input');
  input1.type = 'text';
  input1.className = 'form-control required-input';
  input1.id = 'timestamps[]';
  input1.name = 'timestamps[]';
  input1.placeholder = '0:00';
  input1.required = true;
  col1.appendChild(label1);
  col1.appendChild(input1);

  var col2 = document.createElement('div');
  col2.className = 'col';
  var label2 = document.createElement('label');
  label2.setAttribute('for', 'descriptions[]');
  label2.className = 'form-label';
  label2.textContent = 'Description: ';
  var input2 = document.createElement('input');
  input2.type = 'text';
  input2.className = 'form-control required-input';
  input2.id = 'descriptions[]';
  input2.name = 'descriptions[]';
  input2.placeholder = 'Go to website';
  input2.required = true;
  col2.appendChild(label2);
  col2.appendChild(input2);

  row.appendChild(col1);
  row.appendChild(col2);

 
  container.appendChild(row); // Append the row to the container

  console.log(containerID); // timestampsRows1 or timestampsRows2
  var deleteButton = document.getElementById(deleteButton);
  deleteButton.disabled = false; // Enable the delete button

  // Attach event listener to the new inputs for form validation
  input1.addEventListener('input', () => checkFormValidity(videoButton));
  input2.addEventListener('input', () => checkFormValidity(videoButton));

  // Check form validity initially
  checkFormValidity(videoButton);
}

// remove all value from the form
function cancelVideoButton(containerID, videoButton) {
  const container = document.getElementById(containerID);
  const rows = container.querySelectorAll('.row');
  
  if (container.id === 'uploadVideoForm' && rows.length > 1) {
    const timestampRows = document.getElementById('timestampsRows1');
    timestampRows.innerHTML = ''; // Clear the contents of the container

    var inputs = document.querySelectorAll('.form-control[required]');
    inputs.forEach(function (input) { 
      if (input.closest('#uploadVideoForm')) {  // Check if the input is in the uploadVideoForm
        input.value = ''; // Clear the value of each input in timestampsRows1
      }
    });

    const button = document.getElementById(videoButton);
    button.disabled = true; // Disable the button
    
  }   
}

// Delay for 5 seconds (5000 milliseconds) before fading out and hiding the element
setTimeout(function() {
  $(".alert-pop-up-animation-fade-out").addClass("d-none");
}, 5000);


// set the DOMContentLoaded event to check the form validity
document.addEventListener('DOMContentLoaded', function() {
// Get the form elements for upload video
var uploadForm = document.getElementById('uploadVideoForm');
var uploadFormInputs = uploadForm.querySelectorAll('.form-control[required]');
var uploadFlowchartInput = uploadForm.querySelector('#flowchart');

// Get the form elements for edit video
var editForm = document.getElementById('editVideoForm');
var editFormInputs = editForm.querySelectorAll('.form-control[required]');
var editFlowchartInput = editForm.querySelector('#edit-flowchart');

// Get the submit buttons
var submitUploadVideo = document.getElementById('submitUploadVideo');
var submitEditVideo = document.getElementById('submitEditVideo');

// Add event listeners to the upload form inputs
uploadFormInputs.forEach(function(input) {
  input.addEventListener('input', checkUploadFormValidity);
});

uploadFlowchartInput.addEventListener('input', checkUploadFormValidity);

// Add event listeners to the edit form inputs
editFormInputs.forEach(function(input) {
  input.addEventListener('input', checkEditFormValidity);
});

editFlowchartInput.addEventListener('input', checkEditFormValidity);

// Check if the upload form is valid
checkUploadFormValidity(); // Check initially

// Check if the edit form is valid
checkEditFormValidity(); // Check initially

  // Check if the upload form is valid
  function checkUploadFormValidity() {
    var isValidUpload = Array.from(uploadFormInputs).every(function(input) {
      return input.value !== '';
    });
  
    // Enable or disable the submit button for upload video
    submitUploadVideo.disabled = !isValidUpload;
  }
  
  // Check if the edit form is valid
  function checkEditFormValidity() {
    var isValidEdit = Array.from(editFormInputs).every(function(input) {
      return input.value !== '';
    });
  
    // Enable or disable the submit button for edit video
    submitEditVideo.disabled = !isValidEdit;
  }
});


// Check if the form is valid
function checkFormValidity(submitButtonID) {
  var inputs = document.querySelectorAll('form-control, form-control[required], .required-input[required]');
  var isFormValid = true;

  for (var i = 0; i < inputs.length; i++) {
      if (!inputs[i].value) {
          isFormValid = false;
          break;
      }
  }

  if (submitButtonID === 'submitUploadVideo') { 
    // Check if any empty or blank timestamps exist
    var timestampsRows = document.getElementById('timestampsRows1');
    var timestampInputs = timestampsRows.querySelectorAll('#uploadVideoForm .form-control[required]');
    for (var j = 0; j < timestampInputs.length; j++) {
      if (!timestampInputs[j].value.trim()) {
        isFormValid = false;
        break;
      }
    }

    // Enable or disable the button based on form validity
    var submitButton = document.getElementById(submitButtonID);
    submitButton.disabled = !isFormValid;

  } else if (submitButtonID === 'submitEditVideo') {

    // Enable or disable the button based on form validity
    var submitButton = document.getElementById(submitButtonID);
    submitButton.disabled = !isFormValid;

  } else if (submitButtonID === 'submitUploadQuiz') {

    // Enable or disable the button based on form validity
    var submitButton = document.getElementById(submitButtonID);
    submitButton.disabled = !isFormValid;
  }



}

// Delete the last timestamp row
function deleteTimestamp(containerID, submitButtonID, deleteButtonID) {
  var container = document.getElementById(containerID);
  var rows = container.querySelectorAll('.row');
  var deleteButton = document.getElementById(deleteButtonID);

  if (rows.length > 1) {
    container.removeChild(rows[rows.length - 1]); // Remove the last row

      // Check if any required fields are empty
      var hasEmptyRequiredFields = false;
      var isLastRowEmpty = true;
  
      rows.forEach(function(row, index) {
        var requiredInputs = row.querySelectorAll('.form-control[required]');
        requiredInputs.forEach(function(input) {
          if (input.value.trim() === '') {
            hasEmptyRequiredFields = true;
            return; // Exit the loop early if any required field is empty
          }
        });
  
        if (index === rows.length - 1 && hasEmptyRequiredFields) {
          var inputs = row.querySelectorAll('.form-control');
          inputs.forEach(function(input) {
            if (input.value.trim() !== '') {
              isLastRowEmpty = false;               
              return; // Exit the loop early if any non-empty field is found
            }
          });
        }
      });

    // Enable or disable the delete button and submit button based on form validity
    if (rows.length === 2) {
      deleteButton.disabled = true;
    } else {
      deleteButton.disabled = false;
    }

    checkFormValidity(submitButtonID);
  }
}

 // Add event listener to the file upload input
 document.getElementById('fileUpload').addEventListener('change', function() {
  // const fileName = this.value.split('\\')[this.value.split('\\').length - 1];
  const fileName = this.value.split('\\').pop();
  var docNameInput = document.getElementById('docName');
  docNameInput.value = fileName; // Set the file name to the docName input field
});

// add the quiz elements
function addQuizRow(containerID) {
    
  var container = document.getElementById(containerID);   
  var row = document.createElement('div');
  row.className = 'row';   

   var rowHtml = `
    <div class="row">
      <div class="mb-4 mt-5">
        <input type="text" class="form-control required-input" name="quiz_question[]" placeholder="Quiz Question" required>
      </div>
      <div class="mb-2">
        <input type="text" class="form-control required-input" name="quiz_answer[]" placeholder="Quiz Answer followed by Selection: " 
        maxlength="1" uppercase oninput="this.value = this.value.toUpperCase()" required>
      </div>
      <div class="col-6 mb-4">
          <label class="form-label">Selection</label>
              <input type="text" class="form-control" 
                  name="selections[]" placeholder="A" maxlength="1" uppercase oninput="this.value = this.value.toUpperCase()" required>
      </div>
      <div class="col-6 mb-4">
          <label class="form-label">Answer</label>
              <input type="text" class="form-control" 
                  name="quiz_options[]" placeholder="Click Attendance" required>
      </div>
      <div class="col-6 mb-4">
          <label class="form-label">Selection</label>
              <input type="text" class="form-control" 
                  name="selections[]" placeholder="B" maxlength="1" uppercase oninput="this.value = this.value.toUpperCase()" required>
      </div>
      <div class="col-6 mb-4">
          <label class="form-label">Answer</label>
              <input type="text" class="form-control" 
                  name="quiz_options[]" placeholder="Click Attendance" required>
      </div>
      <div class="col-6 mb-4">
          <label class="form-label">Selection</label>
              <input type="text" class="form-control" 
                  name="selections[]" placeholder="C" maxlength="1" uppercase oninput="this.value = this.value.toUpperCase()" required>
      </div>
      <div class="col-6 mb-4">
          <label class="form-label">Answer</label>
              <input type="text" class="form-control" 
                  name="quiz_options[]" placeholder="Click Attendance" required>
      </div>
      <div class="col-6 mb-4">
          <label class="form-label">Selection</label>
              <input type="text" class="form-control" 
                  name="selections[]" placeholder="D" maxlength="1" uppercase oninput="this.value = this.value.toUpperCase()" required>
      </div>
      <div class="col-6 mb-4">
          <label class="form-label">Answer</label>
              <input type="text" class="form-control"
                  name="quiz_options[]" placeholder="Click Attendance" required>
      </div>
      <div class="mb-4 col-2">
        <button id="deleteQuizRowButton" onclick="deleteQuizRow(event)" type="button" class="btn modal-button">Delete</button>
      </div>      
    </div>
  `;

  row.innerHTML = rowHtml;

  container.appendChild(row); // Append the row to the container

  checkAddQuizFormValidity();
}

// Delete the quiz by specific row
function deleteQuizRow(event) {
  const container = document.getElementById('quizRow');    
  const rows = container.getElementsByClassName('row');

  if (rows.length > 1) {
    const row = event.target.closest('.row');
    if(row){
      row.remove();
      checkAddQuizFormValidity(); // Update the disabled state of the submit button after removing the row
    }
   
  } else {
    alert('You must have at least one quiz question!');
  }
}

document.addEventListener('DOMContentLoaded', function() {
  const editQuizForm = document.getElementById('addQuizForm');
  var quizFormInput = editQuizForm.querySelectorAll('.form-control[required]');      
  var submitUploadQuiz = document.getElementById('submitUploadQuiz');

  // Add event listeners to the edit form inputs
  quizFormInput.forEach(function(input) {
    input.addEventListener('input', checkAddQuizFormValidity);
  });

      // Check if the upload form is valid
      function checkAddQuizFormValidity() {
        var isValidUpload = Array.from(quizFormInput).every(function(input) {
          return input.value !== '';
        });
              
        // Enable or disable the submit button for upload video
        submitUploadQuiz.disabled = !isValidUpload;
      }

  // Initialize the disabled state of the submit button on page load
  checkAddQuizFormValidity();

})

// Check if the edit form is valid
function checkAddQuizFormValidity() {
  const editQuizForm = document.getElementById('addQuizForm');
  var quizFormInput = editQuizForm.querySelectorAll('.form-control[required]');      
  var submitUploadQuiz = document.getElementById('submitUploadQuiz');

    // Add event listeners to the edit form inputs
  quizFormInput.forEach(function(input) {
    input.addEventListener('input', checkAddQuizFormValidity);
  });

      // Check if the upload form is valid
      function checkAddQuizFormValidity() {
        var isValidUpload = Array.from(quizFormInput).every(function(input) {
          return input.value !== '';
        });
              
        // Enable or disable the submit button for upload video
        submitUploadQuiz.disabled = !isValidUpload;
      }

  // Initialize the disabled state of the submit button on page load
  checkAddQuizFormValidity();
}